 


//--AgentGen BEGIN=_BEGIN
//--AgentGen END

#ifndef _if_mib_cpp
#define  _if_mib_cpp

#include <agent_pp/agent++.h>
#include <if_mib.h>
#include <module_includes.h>

//--AgentGen BEGIN=_INCLUDE
//--AgentGen END


#ifdef SNMP_PP_NAMESPACE
using namespace Snmp_pp;
#endif

#ifdef AGENTPP_NAMESPACE
namespace Agentpp {
#endif


static const char *agenProLogModule = "if_mib";

//--AgentGen BEGIN=_UTIL_CLASSES
//--AgentGen END

// Scalar Objects


/**
 *  ifNumber
 *
 * "The number of network interfaces (regardless of their
 * current state) present on this system."
 */
 
if_mib_ifNumber* if_mib_ifNumber::instance = 0;


if_mib_ifNumber::if_mib_ifNumber():
    MibLeaf(oid_IF_MIB_IfNumber, READONLY, new NS_SNMP SnmpInt32()){
	// This leaf object is a singleton. In order to access it use
	// the static pointer if_mib_ifNumber::instance.
	instance = this;
	//--AgentGen BEGIN=ifNumber::if_mib_ifNumber
	//--AgentGen END

}

if_mib_ifNumber::~if_mib_ifNumber()
{

	//--AgentGen BEGIN=ifNumber::~if_mib_ifNumber
	//--AgentGen END

	// clear singleton reference
	if_mib_ifNumber::instance = 0;
}

void if_mib_ifNumber::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifNumber::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifNumber::get_state()
{
	//--AgentGen BEGIN=ifNumber::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifNumber::set_state(long l)
{
	//--AgentGen BEGIN=ifNumber::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

//--AgentGen BEGIN=ifNumber
//--AgentGen END




/**
 *  ifTableLastChange
 *
 * "The value of sysUpTime at the time of the last creation or
 * deletion of an entry in the ifTable.  If the number of
 * entries has been unchanged since the last re-initialization
 * of the local network management subsystem, then this object
 * contains a zero value."
 */
 
if_mib_ifTableLastChange* if_mib_ifTableLastChange::instance = 0;


if_mib_ifTableLastChange::if_mib_ifTableLastChange():
    MibLeaf(oid_IF_MIB_IfTableLastChange, READONLY, new NS_SNMP TimeTicks()){
	// This leaf object is a singleton. In order to access it use
	// the static pointer if_mib_ifTableLastChange::instance.
	instance = this;
	//--AgentGen BEGIN=ifTableLastChange::if_mib_ifTableLastChange
	//--AgentGen END

}

if_mib_ifTableLastChange::~if_mib_ifTableLastChange()
{

	//--AgentGen BEGIN=ifTableLastChange::~if_mib_ifTableLastChange
	//--AgentGen END

	// clear singleton reference
	if_mib_ifTableLastChange::instance = 0;
}

void if_mib_ifTableLastChange::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTableLastChange::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

unsigned long if_mib_ifTableLastChange::get_state()
{
	//--AgentGen BEGIN=ifTableLastChange::get_state
	//--AgentGen END
	return (unsigned long)*((NS_SNMP TimeTicks*)value);
}

void if_mib_ifTableLastChange::set_state(unsigned long l)
{
	//--AgentGen BEGIN=ifTableLastChange::set_state
	//--AgentGen END
	*((NS_SNMP TimeTicks*)value) = l;
}


//--AgentGen BEGIN=ifTableLastChange
//--AgentGen END




/**
 *  ifStackLastChange
 *
 * "The value of sysUpTime at the time of the last change of
 * the (whole) interface stack.  A change of the interface
 * stack is defined to be any creation, deletion, or change in
 * value of any instance of ifStackStatus.  If the interface
 * stack has been unchanged since the last re-initialization of
 * the local network management subsystem, then this object
 * contains a zero value."
 */
 
if_mib_ifStackLastChange* if_mib_ifStackLastChange::instance = 0;


if_mib_ifStackLastChange::if_mib_ifStackLastChange():
    MibLeaf(oid_IF_MIB_IfStackLastChange, READONLY, new NS_SNMP TimeTicks()){
	// This leaf object is a singleton. In order to access it use
	// the static pointer if_mib_ifStackLastChange::instance.
	instance = this;
	//--AgentGen BEGIN=ifStackLastChange::if_mib_ifStackLastChange
	//--AgentGen END

}

if_mib_ifStackLastChange::~if_mib_ifStackLastChange()
{

	//--AgentGen BEGIN=ifStackLastChange::~if_mib_ifStackLastChange
	//--AgentGen END

	// clear singleton reference
	if_mib_ifStackLastChange::instance = 0;
}

void if_mib_ifStackLastChange::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifStackLastChange::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

unsigned long if_mib_ifStackLastChange::get_state()
{
	//--AgentGen BEGIN=ifStackLastChange::get_state
	//--AgentGen END
	return (unsigned long)*((NS_SNMP TimeTicks*)value);
}

void if_mib_ifStackLastChange::set_state(unsigned long l)
{
	//--AgentGen BEGIN=ifStackLastChange::set_state
	//--AgentGen END
	*((NS_SNMP TimeTicks*)value) = l;
}


//--AgentGen BEGIN=ifStackLastChange
//--AgentGen END



// Columnar Objects


/**
 *  ifAdminStatus
 *
 * "The desired state of the interface.  The testing(3) state
 * indicates that no operational packets can be passed.  When a
 * managed system initializes, all interfaces start with
 * ifAdminStatus in the down(2) state.  As a result of either
 * explicit management action or per configuration information
 * retained by the managed system, ifAdminStatus is then
 * changed to either the up(1) or testing(3) states (or remains
 * in the down(2) state)."
 */
 
if_mib_ifAdminStatus::if_mib_ifAdminStatus(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP SnmpInt32()){
	//--AgentGen BEGIN=ifAdminStatus::if_mib_ifAdminStatus
	//--AgentGen END

}

if_mib_ifAdminStatus::~if_mib_ifAdminStatus()
{

	//--AgentGen BEGIN=ifAdminStatus::~if_mib_ifAdminStatus
	//--AgentGen END

}

MibEntryPtr if_mib_ifAdminStatus::clone()
{
	MibEntryPtr other = new if_mib_ifAdminStatus(oid);
	((if_mib_ifAdminStatus*)other)->replace_value(value->clone());
	((if_mib_ifAdminStatus*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifAdminStatus::clone
	//--AgentGen END
	return other;
}

void if_mib_ifAdminStatus::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifAdminStatus::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifAdminStatus::get_state()
{
	//--AgentGen BEGIN=ifAdminStatus::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifAdminStatus::set_state(long l)
{
	//--AgentGen BEGIN=ifAdminStatus::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifAdminStatus::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifAdminStatus::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifAdminStatus::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifAdminStatus::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifAdminStatus::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifAdminStatus::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifAdminStatus::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifAdminStatus::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifAdminStatus::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifAdminStatus::value_ok(const Vbx& vb)
{
	long v;
	vb.get_value(v);
	if ((v != 1) 
	     && (v != 2) && (v != 3) 
	    ) return FALSE;
	//--AgentGen BEGIN=ifAdminStatus::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifAdminStatus::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifAdminStatus::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifAdminStatus
//--AgentGen END




/**
 *  ifLinkUpDownTrapEnable
 *
 * "Indicates whether linkUp/linkDown traps should be generated
 * for this interface.

 * By default, this object should have the value enabled(1) for
 * interfaces which do not operate on 'top' of any other
 * interface (as defined in the ifStackTable), and disabled(2)
 * otherwise."
 */
 
if_mib_ifLinkUpDownTrapEnable::if_mib_ifLinkUpDownTrapEnable(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP SnmpInt32()){
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::if_mib_ifLinkUpDownTrapEnable
	//--AgentGen END

}

if_mib_ifLinkUpDownTrapEnable::~if_mib_ifLinkUpDownTrapEnable()
{

	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::~if_mib_ifLinkUpDownTrapEnable
	//--AgentGen END

}

MibEntryPtr if_mib_ifLinkUpDownTrapEnable::clone()
{
	MibEntryPtr other = new if_mib_ifLinkUpDownTrapEnable(oid);
	((if_mib_ifLinkUpDownTrapEnable*)other)->replace_value(value->clone());
	((if_mib_ifLinkUpDownTrapEnable*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::clone
	//--AgentGen END
	return other;
}

void if_mib_ifLinkUpDownTrapEnable::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifLinkUpDownTrapEnable::get_state()
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifLinkUpDownTrapEnable::set_state(long l)
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifLinkUpDownTrapEnable::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifLinkUpDownTrapEnable::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifLinkUpDownTrapEnable::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifLinkUpDownTrapEnable::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifLinkUpDownTrapEnable::value_ok(const Vbx& vb)
{
	long v;
	vb.get_value(v);
	if ((v != 1) 
	     && (v != 2)) return FALSE;
	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifLinkUpDownTrapEnable::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifLinkUpDownTrapEnable::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifLinkUpDownTrapEnable
//--AgentGen END




/**
 *  ifPromiscuousMode
 *
 * "This object has a value of false(2) if this interface only
 * accepts packets/frames that are addressed to this station.
 * This object has a value of true(1) when the station accepts
 * all packets/frames transmitted on the media.  The value
 * true(1) is only legal on certain types of media.  If legal,
 * setting this object to a value of true(1) may require the
 * interface to be reset before becoming effective.

 * The value of ifPromiscuousMode does not affect the reception
 * of broadcast and multicast packets/frames by the interface."
 */
 
if_mib_ifPromiscuousMode::if_mib_ifPromiscuousMode(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP SnmpInt32()){
	//--AgentGen BEGIN=ifPromiscuousMode::if_mib_ifPromiscuousMode
	//--AgentGen END

}

if_mib_ifPromiscuousMode::~if_mib_ifPromiscuousMode()
{

	//--AgentGen BEGIN=ifPromiscuousMode::~if_mib_ifPromiscuousMode
	//--AgentGen END

}

MibEntryPtr if_mib_ifPromiscuousMode::clone()
{
	MibEntryPtr other = new if_mib_ifPromiscuousMode(oid);
	((if_mib_ifPromiscuousMode*)other)->replace_value(value->clone());
	((if_mib_ifPromiscuousMode*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifPromiscuousMode::clone
	//--AgentGen END
	return other;
}

void if_mib_ifPromiscuousMode::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifPromiscuousMode::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifPromiscuousMode::get_state()
{
	//--AgentGen BEGIN=ifPromiscuousMode::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifPromiscuousMode::set_state(long l)
{
	//--AgentGen BEGIN=ifPromiscuousMode::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifPromiscuousMode::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifPromiscuousMode::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifPromiscuousMode::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifPromiscuousMode::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifPromiscuousMode::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifPromiscuousMode::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifPromiscuousMode::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifPromiscuousMode::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifPromiscuousMode::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifPromiscuousMode::value_ok(const Vbx& vb)
{
	long v;
	vb.get_value(v);
	if ((v != 1) 
	     && (v != 2)) return FALSE;
	//--AgentGen BEGIN=ifPromiscuousMode::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifPromiscuousMode::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifPromiscuousMode::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifPromiscuousMode
//--AgentGen END




/**
 *  ifAlias
 *
 * "This object is an 'alias' name for the interface as
 * specified by a network manager, and provides a non-volatile
 * 'handle' for the interface.

 * On the first instantiation of an interface, the value of
 * ifAlias associated with that interface is the zero-length
 * string.  As and when a value is written into an instance of
 * ifAlias through a network management set operation, then the
 * agent must retain the supplied value in the ifAlias instance
 * associated with the same interface for as long as that
 * interface remains instantiated, including across all re-
 * initializations/reboots of the network management system,
 * including those which result in a change of the interface's
 * ifIndex value.

 * An example of the value which a network manager might store
 * in this object for a WAN interface is the (Telco's) circuit
 * number/identifier of the interface.

 * Some agents may support write-access only for interfaces
 * having particular values of ifType.  An agent which supports
 * write access to this object is required to keep the value in
 * non-volatile storage, but it may limit the length of new
 * values depending on how much storage is already occupied by
 * the current values for other interfaces."
 */
 
if_mib_ifAlias::if_mib_ifAlias(const Oidx& id):
    SnmpDisplayString(id, READWRITE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=ifAlias::if_mib_ifAlias
	//--AgentGen END

}

if_mib_ifAlias::~if_mib_ifAlias()
{

	//--AgentGen BEGIN=ifAlias::~if_mib_ifAlias
	//--AgentGen END

}

MibEntryPtr if_mib_ifAlias::clone()
{
	MibEntryPtr other = new if_mib_ifAlias(oid);
	((if_mib_ifAlias*)other)->replace_value(value->clone());
	((if_mib_ifAlias*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifAlias::clone
	//--AgentGen END
	return other;
}

void if_mib_ifAlias::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifAlias::get_request
	//--AgentGen END
	SnmpDisplayString::get_request(req, ind);
}

NS_SNMP OctetStr if_mib_ifAlias::get_state() {
	//--AgentGen BEGIN=ifAlias::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void if_mib_ifAlias::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=ifAlias::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int if_mib_ifAlias::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifAlias::set
	//--AgentGen END
	return SnmpDisplayString::set(vb);
}

int if_mib_ifAlias::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifAlias::commit_set_request
	//--AgentGen END
	int status = SnmpDisplayString::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifAlias::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifAlias::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifAlias::cleanup_set_request
	//--AgentGen END
	SnmpDisplayString::cleanup_set_request(req, ind);
}

int if_mib_ifAlias::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifAlias::undo_set_request
	//--AgentGen END
	return SnmpDisplayString::undo_set_request(req, ind);
}

bool if_mib_ifAlias::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=ifAlias::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifAlias::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = SnmpDisplayString::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	NS_SNMP Vb vb(req->get_value(ind));
	NS_SNMP OctetStr v;
	vb.get_value(v);
	if (!(((v.len() >= 0) && (v.len() <= 64))))
		 return SNMP_ERROR_WRONG_LENGTH;
	//--AgentGen BEGIN=ifAlias::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifAlias
//--AgentGen END




/**
 *  ifStackStatus
 *
 * "The status of the relationship between two sub-layers.

 * Changing the value of this object from 'active' to
 * 'notInService' or 'destroy' will likely have consequences up
 * and down the interface stack.  Thus, write access to this
 * object is likely to be inappropriate for some types of
 * interfaces, and many implementations will choose not to
 * support write-access for any type of interface."
 */
 
if_mib_ifStackStatus::if_mib_ifStackStatus(const Oidx& id):
    snmpRowStatus(id, READCREATE)
{
	//--AgentGen BEGIN=ifStackStatus::if_mib_ifStackStatus
	//--AgentGen END

}

if_mib_ifStackStatus::~if_mib_ifStackStatus()
{

	//--AgentGen BEGIN=ifStackStatus::~if_mib_ifStackStatus
	//--AgentGen END

}

MibEntryPtr if_mib_ifStackStatus::clone()
{
	MibEntryPtr other = new if_mib_ifStackStatus(oid);
	((if_mib_ifStackStatus*)other)->replace_value(value->clone());
	((if_mib_ifStackStatus*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifStackStatus::clone
	//--AgentGen END
	return other;
}

long if_mib_ifStackStatus::get_state()
{
	//--AgentGen BEGIN=ifStackStatus::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifStackStatus::set_state(long l)
{
	//--AgentGen BEGIN=ifStackStatus::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifStackStatus::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifStackStatus::set
	//--AgentGen END
	return snmpRowStatus::set(vb);
}

int if_mib_ifStackStatus::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifStackStatus::commit_set_request
	//--AgentGen END
	int status = snmpRowStatus::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifStackStatus::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifStackStatus::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifStackStatus::cleanup_set_request
	//--AgentGen END
	snmpRowStatus::cleanup_set_request(req, ind);
}

int if_mib_ifStackStatus::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifStackStatus::undo_set_request
	//--AgentGen END
	return snmpRowStatus::undo_set_request(req, ind);
}

int if_mib_ifStackStatus::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = snmpRowStatus::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifStackStatus::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifStackStatus
//--AgentGen END




/**
 *  ifTestId
 *
 * "This object identifies the current invocation of the
 * interface's test."
 */
 
if_mib_ifTestId::if_mib_ifTestId(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP SnmpInt32()){
	//--AgentGen BEGIN=ifTestId::if_mib_ifTestId
	//--AgentGen END

}

if_mib_ifTestId::~if_mib_ifTestId()
{

	//--AgentGen BEGIN=ifTestId::~if_mib_ifTestId
	//--AgentGen END

}

MibEntryPtr if_mib_ifTestId::clone()
{
	MibEntryPtr other = new if_mib_ifTestId(oid);
	((if_mib_ifTestId*)other)->replace_value(value->clone());
	((if_mib_ifTestId*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifTestId::clone
	//--AgentGen END
	return other;
}

void if_mib_ifTestId::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestId::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifTestId::get_state()
{
	//--AgentGen BEGIN=ifTestId::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifTestId::set_state(long l)
{
	//--AgentGen BEGIN=ifTestId::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifTestId::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifTestId::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifTestId::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestId::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifTestId::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifTestId::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestId::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifTestId::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestId::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifTestId::value_ok(const Vbx& vb)
{
	long v;
	vb.get_value(v);
	if (!(((v >= 0) && (v <= 2147483647))))
		 return FALSE;
	//--AgentGen BEGIN=ifTestId::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifTestId::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifTestId::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifTestId
//--AgentGen END




/**
 *  ifTestStatus
 *
 * "This object indicates whether or not some manager currently
 * has the necessary 'ownership' required to invoke a test on
 * this interface.  A write to this object is only successful
 * when it changes its value from 'notInUse(1)' to 'inUse(2)'.
 * After completion of a test, the agent resets the value back
 * to 'notInUse(1)'."
 */
 
if_mib_ifTestStatus::if_mib_ifTestStatus(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP SnmpInt32()){
	//--AgentGen BEGIN=ifTestStatus::if_mib_ifTestStatus
	//--AgentGen END

}

if_mib_ifTestStatus::~if_mib_ifTestStatus()
{

	//--AgentGen BEGIN=ifTestStatus::~if_mib_ifTestStatus
	//--AgentGen END

}

MibEntryPtr if_mib_ifTestStatus::clone()
{
	MibEntryPtr other = new if_mib_ifTestStatus(oid);
	((if_mib_ifTestStatus*)other)->replace_value(value->clone());
	((if_mib_ifTestStatus*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifTestStatus::clone
	//--AgentGen END
	return other;
}

void if_mib_ifTestStatus::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestStatus::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifTestStatus::get_state()
{
	//--AgentGen BEGIN=ifTestStatus::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifTestStatus::set_state(long l)
{
	//--AgentGen BEGIN=ifTestStatus::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifTestStatus::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifTestStatus::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifTestStatus::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestStatus::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifTestStatus::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifTestStatus::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestStatus::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifTestStatus::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestStatus::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifTestStatus::value_ok(const Vbx& vb)
{
	long v;
	vb.get_value(v);
	if ((v != 1) 
	     && (v != 2)) return FALSE;
	//--AgentGen BEGIN=ifTestStatus::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifTestStatus::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifTestStatus::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifTestStatus
//--AgentGen END




/**
 *  ifTestType
 *
 * "A control variable used to start and stop operator-
 * initiated interface tests.  Most OBJECT IDENTIFIER values
 * assigned to tests are defined elsewhere, in association with
 * specific types of interface.  However, this document assigns
 * a value for a full-duplex loopback test, and defines the
 * special meanings of the subject identifier:

 *     noTest  OBJECT IDENTIFIER ::= { 0 0 }

 * When the value noTest is written to this object, no action
 * is taken unless a test is in progress, in which case the
 * test is aborted.  Writing any other value to this object is
 * only valid when no test is currently in progress, in which
 * case the indicated test is initiated.

 * When read, this object always returns the most recent value
 * that ifTestType was set to.  If it has not been set since
 * the last initialization of the network management subsystem
 * on the agent, a value of noTest is returned."
 */
 
if_mib_ifTestType::if_mib_ifTestType(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP Oid()){
	//--AgentGen BEGIN=ifTestType::if_mib_ifTestType
	//--AgentGen END

}

if_mib_ifTestType::~if_mib_ifTestType()
{

	//--AgentGen BEGIN=ifTestType::~if_mib_ifTestType
	//--AgentGen END

}

MibEntryPtr if_mib_ifTestType::clone()
{
	MibEntryPtr other = new if_mib_ifTestType(oid);
	((if_mib_ifTestType*)other)->replace_value(value->clone());
	((if_mib_ifTestType*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifTestType::clone
	//--AgentGen END
	return other;
}

void if_mib_ifTestType::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestType::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}


int if_mib_ifTestType::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifTestType::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifTestType::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestType::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifTestType::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifTestType::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestType::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifTestType::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestType::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifTestType::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=ifTestType::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifTestType::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifTestType::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifTestType
//--AgentGen END




/**
 *  ifTestOwner
 *
 * "The entity which currently has the 'ownership' required to
 * invoke a test on this interface."
 */
 
if_mib_ifTestOwner::if_mib_ifTestOwner(const Oidx& id):
    MibLeaf(id, READWRITE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=ifTestOwner::if_mib_ifTestOwner
	//--AgentGen END

}

if_mib_ifTestOwner::~if_mib_ifTestOwner()
{

	//--AgentGen BEGIN=ifTestOwner::~if_mib_ifTestOwner
	//--AgentGen END

}

MibEntryPtr if_mib_ifTestOwner::clone()
{
	MibEntryPtr other = new if_mib_ifTestOwner(oid);
	((if_mib_ifTestOwner*)other)->replace_value(value->clone());
	((if_mib_ifTestOwner*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifTestOwner::clone
	//--AgentGen END
	return other;
}

void if_mib_ifTestOwner::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestOwner::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr if_mib_ifTestOwner::get_state() {
	//--AgentGen BEGIN=ifTestOwner::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void if_mib_ifTestOwner::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=ifTestOwner::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int if_mib_ifTestOwner::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifTestOwner::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifTestOwner::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestOwner::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifTestOwner::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifTestOwner::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestOwner::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifTestOwner::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestOwner::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifTestOwner::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=ifTestOwner::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifTestOwner::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	NS_SNMP Vb vb(req->get_value(ind));
	NS_SNMP OctetStr v;
	vb.get_value(v);
	if (!(((v.len() >= 0) && (v.len() <= 255))))
		 return SNMP_ERROR_WRONG_LENGTH;
	//--AgentGen BEGIN=ifTestOwner::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifTestOwner
//--AgentGen END




/**
 *  ifRcvAddressStatus
 *
 * "This object is used to create and delete rows in the
 * ifRcvAddressTable."
 */
 
if_mib_ifRcvAddressStatus::if_mib_ifRcvAddressStatus(const Oidx& id):
    snmpRowStatus(id, READCREATE)
{
	//--AgentGen BEGIN=ifRcvAddressStatus::if_mib_ifRcvAddressStatus
	//--AgentGen END

}

if_mib_ifRcvAddressStatus::~if_mib_ifRcvAddressStatus()
{

	//--AgentGen BEGIN=ifRcvAddressStatus::~if_mib_ifRcvAddressStatus
	//--AgentGen END

}

MibEntryPtr if_mib_ifRcvAddressStatus::clone()
{
	MibEntryPtr other = new if_mib_ifRcvAddressStatus(oid);
	((if_mib_ifRcvAddressStatus*)other)->replace_value(value->clone());
	((if_mib_ifRcvAddressStatus*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifRcvAddressStatus::clone
	//--AgentGen END
	return other;
}

long if_mib_ifRcvAddressStatus::get_state()
{
	//--AgentGen BEGIN=ifRcvAddressStatus::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifRcvAddressStatus::set_state(long l)
{
	//--AgentGen BEGIN=ifRcvAddressStatus::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifRcvAddressStatus::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifRcvAddressStatus::set
	//--AgentGen END
	return snmpRowStatus::set(vb);
}

int if_mib_ifRcvAddressStatus::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifRcvAddressStatus::commit_set_request
	//--AgentGen END
	int status = snmpRowStatus::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifRcvAddressStatus::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifRcvAddressStatus::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressStatus::cleanup_set_request
	//--AgentGen END
	snmpRowStatus::cleanup_set_request(req, ind);
}

int if_mib_ifRcvAddressStatus::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressStatus::undo_set_request
	//--AgentGen END
	return snmpRowStatus::undo_set_request(req, ind);
}

int if_mib_ifRcvAddressStatus::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = snmpRowStatus::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifRcvAddressStatus::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifRcvAddressStatus
//--AgentGen END




/**
 *  ifRcvAddressType
 *
 * "This object has the value nonVolatile(3) for those entries
 * in the table which are valid and will not be deleted by the
 * next restart of the managed system.  Entries having the
 * value volatile(2) are valid and exist, but have not been
 * saved, so that will not exist after the next restart of the
 * managed system.  Entries having the value other(1) are valid
 * and exist but are not classified as to whether they will
 * continue to exist after the next restart."
 */
 
if_mib_ifRcvAddressType::if_mib_ifRcvAddressType(const Oidx& id):
    MibLeaf(id, READCREATE, new NS_SNMP SnmpInt32(2), VMODE_DEFAULT){
	//--AgentGen BEGIN=ifRcvAddressType::if_mib_ifRcvAddressType
	//--AgentGen END

}

if_mib_ifRcvAddressType::~if_mib_ifRcvAddressType()
{

	//--AgentGen BEGIN=ifRcvAddressType::~if_mib_ifRcvAddressType
	//--AgentGen END

}

MibEntryPtr if_mib_ifRcvAddressType::clone()
{
	MibEntryPtr other = new if_mib_ifRcvAddressType(oid);
	((if_mib_ifRcvAddressType*)other)->replace_value(value->clone());
	((if_mib_ifRcvAddressType*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=ifRcvAddressType::clone
	//--AgentGen END
	return other;
}

void if_mib_ifRcvAddressType::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifRcvAddressType::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

long if_mib_ifRcvAddressType::get_state()
{
	//--AgentGen BEGIN=ifRcvAddressType::get_state
	//--AgentGen END
	return (long)*((NS_SNMP SnmpInt32*)value);
}
	
void if_mib_ifRcvAddressType::set_state(long l)
{
	//--AgentGen BEGIN=ifRcvAddressType::set_state
	//--AgentGen END
	*((NS_SNMP SnmpInt32*)value) = l;
}
	

int if_mib_ifRcvAddressType::set(const Vbx& vb)
{
	//--AgentGen BEGIN=ifRcvAddressType::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int if_mib_ifRcvAddressType::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifRcvAddressType::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifRcvAddressType::commit_set_request2
	//--AgentGen END
	return status;
}

void if_mib_ifRcvAddressType::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressType::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int if_mib_ifRcvAddressType::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressType::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool if_mib_ifRcvAddressType::value_ok(const Vbx& vb)
{
	long v;
	vb.get_value(v);
	if ((v != 1) 
	     && (v != 2) && (v != 3) 
	    ) return FALSE;
	//--AgentGen BEGIN=ifRcvAddressType::value_ok
	//--AgentGen END
	return TRUE;
}

int if_mib_ifRcvAddressType::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=ifRcvAddressType::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=ifRcvAddressType
//--AgentGen END



// Tables


/**
 *  ifEntry
 *
 * "An entry containing management information applicable to a
 * particular interface."
 */
 
if_mib_ifEntry* if_mib_ifEntry::instance = 0;

const index_info ind_IF_MIB_IfEntry[1] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 }};

if_mib_ifEntry::if_mib_ifEntry():
   MibTable(oid_IF_MIB_IfEntry, ind_IF_MIB_IfEntry, 1)
{
	// This table object is a singleton. In order to access it use
	// the static pointer if_mib_ifEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_IF_MIB_IfIndex, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new SnmpDisplayString(col_IF_MIB_IfDescr, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_IF_MIB_IfType, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_IF_MIB_IfMtu, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_IF_MIB_IfSpeed, READONLY, new NS_SNMP Gauge32()));
	add_col(new MibLeaf(col_IF_MIB_IfPhysAddress, READONLY, new NS_SNMP OctetStr()));
	add_col(new if_mib_ifAdminStatus(col_IF_MIB_IfAdminStatus));
	add_col(new MibLeaf(col_IF_MIB_IfOperStatus, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_IF_MIB_IfLastChange, READONLY, new NS_SNMP TimeTicks()));
	add_col(new MibLeaf(col_IF_MIB_IfInOctets, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfInUcastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfInNUcastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfInDiscards, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfInErrors, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfInUnknownProtos, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutOctets, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutUcastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutNUcastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutDiscards, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutErrors, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutQLen, READONLY, new NS_SNMP Gauge32()));
	add_col(new MibLeaf(col_IF_MIB_IfSpecific, READONLY, new NS_SNMP Oid()));
	//--AgentGen BEGIN=ifEntry::if_mib_ifEntry
	//--AgentGen END
}

if_mib_ifEntry::~if_mib_ifEntry()
{
	//--AgentGen BEGIN=ifEntry::~if_mib_ifEntry
	//--AgentGen END
	// clear singleton reference
	if_mib_ifEntry::instance = 0;
}

void if_mib_ifEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=ifEntry::row_added
	//--AgentGen END
}

void if_mib_ifEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int if_mib_ifEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int if_mib_ifEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void if_mib_ifEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int if_mib_ifEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void if_mib_ifEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=ifEntry::row_delete
	//--AgentGen END
}

void if_mib_ifEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=ifEntry::row_init
	//--AgentGen END
}

void if_mib_ifEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=ifEntry::row_activated
	//--AgentGen END
}

void if_mib_ifEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=ifEntry::row_deactivated
	//--AgentGen END
}

void if_mib_ifEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=ifEntry::update
	//--AgentGen END
}

int if_mib_ifEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                      int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=ifEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void if_mib_ifEntry::set_row(MibTableRow* r, long p1, const NS_SNMP OctetStr& p2, long p3
		, long p4, unsigned long p5, const NS_SNMP OctetStr& p6
		, long p7, long p8, unsigned long p9
		, unsigned long p10, unsigned long p11, unsigned long p12
		, unsigned long p13, unsigned long p14, unsigned long p15
		, unsigned long p16, unsigned long p17, unsigned long p18
		, unsigned long p19, unsigned long p20, unsigned long p21
		, const char* p22)
{
	r->get_nth(0)->replace_value(new NS_SNMP SnmpInt32(p1));
	r->get_nth(1)->replace_value(new NS_SNMP OctetStr(p2));
	r->get_nth(2)->replace_value(new NS_SNMP SnmpInt32(p3));
	r->get_nth(3)->replace_value(new NS_SNMP SnmpInt32(p4));
	r->get_nth(4)->replace_value(new NS_SNMP Gauge32(p5));
	r->get_nth(5)->replace_value(new NS_SNMP OctetStr(p6));
	r->get_nth(6)->replace_value(new NS_SNMP SnmpInt32(p7));
	r->get_nth(7)->replace_value(new NS_SNMP SnmpInt32(p8));
	r->get_nth(8)->replace_value(new NS_SNMP TimeTicks(p9));
	r->get_nth(9)->replace_value(new NS_SNMP Counter32(p10));
	r->get_nth(10)->replace_value(new NS_SNMP Counter32(p11));
	r->get_nth(11)->replace_value(new NS_SNMP Counter32(p12));
	r->get_nth(12)->replace_value(new NS_SNMP Counter32(p13));
	r->get_nth(13)->replace_value(new NS_SNMP Counter32(p14));
	r->get_nth(14)->replace_value(new NS_SNMP Counter32(p15));
	r->get_nth(15)->replace_value(new NS_SNMP Counter32(p16));
	r->get_nth(16)->replace_value(new NS_SNMP Counter32(p17));
	r->get_nth(17)->replace_value(new NS_SNMP Counter32(p18));
	r->get_nth(18)->replace_value(new NS_SNMP Counter32(p19));
	r->get_nth(19)->replace_value(new NS_SNMP Counter32(p20));
	r->get_nth(20)->replace_value(new NS_SNMP Gauge32(p21));
	r->get_nth(21)->replace_value(new NS_SNMP Oid(p22));
}

//--AgentGen BEGIN=ifEntry
//--AgentGen END


/**
 *  ifXEntry
 *
 * "An entry containing additional management information
 * applicable to a particular interface."
 */
 
if_mib_ifXEntry* if_mib_ifXEntry::instance = 0;

const index_info ind_IF_MIB_IfXEntry[1] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 }};

if_mib_ifXEntry::if_mib_ifXEntry():
   MibTable(oid_IF_MIB_IfXEntry, ind_IF_MIB_IfXEntry, 1)
{
	// This table object is a singleton. In order to access it use
	// the static pointer if_mib_ifXEntry::instance.
	instance = this;

	add_col(new SnmpDisplayString(col_IF_MIB_IfName, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_IF_MIB_IfInMulticastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfInBroadcastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutMulticastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfOutBroadcastPkts, READONLY, new NS_SNMP Counter32()));
	add_col(new MibLeaf(col_IF_MIB_IfHCInOctets, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCInUcastPkts, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCInMulticastPkts, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCInBroadcastPkts, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCOutOctets, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCOutUcastPkts, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCOutMulticastPkts, READONLY, new NS_SNMP Counter64()));
	add_col(new MibLeaf(col_IF_MIB_IfHCOutBroadcastPkts, READONLY, new NS_SNMP Counter64()));
	add_col(new if_mib_ifLinkUpDownTrapEnable(col_IF_MIB_IfLinkUpDownTrapEnable));
	add_col(new MibLeaf(col_IF_MIB_IfHighSpeed, READONLY, new NS_SNMP Gauge32()));
	add_col(new if_mib_ifPromiscuousMode(col_IF_MIB_IfPromiscuousMode));
	add_col(new MibLeaf(col_IF_MIB_IfConnectorPresent, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new if_mib_ifAlias(col_IF_MIB_IfAlias));
	add_col(new MibLeaf(col_IF_MIB_IfCounterDiscontinuityTime, READONLY, new NS_SNMP TimeTicks()));
	//--AgentGen BEGIN=ifXEntry::if_mib_ifXEntry
	//--AgentGen END
        // If the code below does not suite your needs or
        // does not compile, because the parent table is
        // named differently, then add "/*" as last line 
        // to your user code.
	if (if_mib_ifEntry::instance) {
		if_mib_ifEntry::instance->add_listener(this);
	}
	else {
		LOG_BEGIN(agenProLogModule, WARNING_LOG | 1);
		LOG("Please instantiate if_mib_ifEntry before ifXEntry");
		LOG_END;
	}
}

if_mib_ifXEntry::~if_mib_ifXEntry()
{
	//--AgentGen BEGIN=ifXEntry::~if_mib_ifXEntry
	//--AgentGen END
	// clear singleton reference
	if_mib_ifXEntry::instance = 0;
        // If the code below does not suite your needs or
        // does not compile, because the parent table is
        // named differently, then add "/*" as last line 
        // to your user code.
	if (if_mib_ifEntry::instance) {
		if_mib_ifEntry::instance->remove_listener(this);
	}	
	//*/	
}

void if_mib_ifXEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=ifXEntry::row_added
	//--AgentGen END
	if (src) add_row(index);	
}

void if_mib_ifXEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifXEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int if_mib_ifXEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifXEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifXEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int if_mib_ifXEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifXEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void if_mib_ifXEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifXEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int if_mib_ifXEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifXEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void if_mib_ifXEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=ifXEntry::row_delete
	//--AgentGen END
	if (src) remove_row(index);	
}

void if_mib_ifXEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=ifXEntry::row_init
	//--AgentGen END
}

void if_mib_ifXEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=ifXEntry::row_activated
	//--AgentGen END
}

void if_mib_ifXEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=ifXEntry::row_deactivated
	//--AgentGen END
}

void if_mib_ifXEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=ifXEntry::update
	//--AgentGen END
}

int if_mib_ifXEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                       int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=ifXEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void if_mib_ifXEntry::set_row(MibTableRow* r, const NS_SNMP OctetStr& p1, unsigned long p2, unsigned long p3
		, unsigned long p4, unsigned long p5, unsigned long p6hi, unsigned long p6lo
		, unsigned long p7hi, unsigned long p7lo, unsigned long p8hi, unsigned long p8lo, unsigned long p9hi, unsigned long p9lo
		, unsigned long p10hi, unsigned long p10lo, unsigned long p11hi, unsigned long p11lo, unsigned long p12hi, unsigned long p12lo
		, unsigned long p13hi, unsigned long p13lo, long p14, unsigned long p15
		, long p16, long p17, const NS_SNMP OctetStr& p18
		, unsigned long p19)
{
	r->get_nth(0)->replace_value(new NS_SNMP OctetStr(p1));
	r->get_nth(1)->replace_value(new NS_SNMP Counter32(p2));
	r->get_nth(2)->replace_value(new NS_SNMP Counter32(p3));
	r->get_nth(3)->replace_value(new NS_SNMP Counter32(p4));
	r->get_nth(4)->replace_value(new NS_SNMP Counter32(p5));
	r->get_nth(5)->replace_value(new NS_SNMP Counter64(p6hi, p6lo));
	r->get_nth(6)->replace_value(new NS_SNMP Counter64(p7hi, p7lo));
	r->get_nth(7)->replace_value(new NS_SNMP Counter64(p8hi, p8lo));
	r->get_nth(8)->replace_value(new NS_SNMP Counter64(p9hi, p9lo));
	r->get_nth(9)->replace_value(new NS_SNMP Counter64(p10hi, p10lo));
	r->get_nth(10)->replace_value(new NS_SNMP Counter64(p11hi, p11lo));
	r->get_nth(11)->replace_value(new NS_SNMP Counter64(p12hi, p12lo));
	r->get_nth(12)->replace_value(new NS_SNMP Counter64(p13hi, p13lo));
	r->get_nth(13)->replace_value(new NS_SNMP SnmpInt32(p14));
	r->get_nth(14)->replace_value(new NS_SNMP Gauge32(p15));
	r->get_nth(15)->replace_value(new NS_SNMP SnmpInt32(p16));
	r->get_nth(16)->replace_value(new NS_SNMP SnmpInt32(p17));
	r->get_nth(17)->replace_value(new NS_SNMP OctetStr(p18));
	r->get_nth(18)->replace_value(new NS_SNMP TimeTicks(p19));
}

//--AgentGen BEGIN=ifXEntry
//--AgentGen END


/**
 *  ifStackEntry
 *
 * "Information on a particular relationship between two sub-
 * layers, specifying that one sub-layer runs on 'top' of the
 * other sub-layer.  Each sub-layer corresponds to a conceptual
 * row in the ifTable."
 */
 
if_mib_ifStackEntry* if_mib_ifStackEntry::instance = 0;

const index_info ind_IF_MIB_IfStackEntry[2] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 },
	 { sNMP_SYNTAX_INT, FALSE, 1, 1 }};

if_mib_ifStackEntry::if_mib_ifStackEntry():
   MibTable(oid_IF_MIB_IfStackEntry, ind_IF_MIB_IfStackEntry, 2)
{
	// This table object is a singleton. In order to access it use
	// the static pointer if_mib_ifStackEntry::instance.
	instance = this;

	add_col(new if_mib_ifStackStatus(col_IF_MIB_IfStackStatus));
	//--AgentGen BEGIN=ifStackEntry::if_mib_ifStackEntry
	//--AgentGen END
}

if_mib_ifStackEntry::~if_mib_ifStackEntry()
{
	//--AgentGen BEGIN=ifStackEntry::~if_mib_ifStackEntry
	//--AgentGen END
	// clear singleton reference
	if_mib_ifStackEntry::instance = 0;
}

void if_mib_ifStackEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=ifStackEntry::row_added
	//--AgentGen END
}

void if_mib_ifStackEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifStackEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int if_mib_ifStackEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifStackEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifStackEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int if_mib_ifStackEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifStackEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void if_mib_ifStackEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifStackEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int if_mib_ifStackEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifStackEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void if_mib_ifStackEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=ifStackEntry::row_delete
	//--AgentGen END
}

void if_mib_ifStackEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=ifStackEntry::row_init
	//--AgentGen END
}

void if_mib_ifStackEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=ifStackEntry::row_activated
	//--AgentGen END
}

void if_mib_ifStackEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=ifStackEntry::row_deactivated
	//--AgentGen END
}

void if_mib_ifStackEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=ifStackEntry::update
	//--AgentGen END
}

int if_mib_ifStackEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                           int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=ifStackEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void if_mib_ifStackEntry::set_row(MibTableRow* r, long p1)
{
	r->get_nth(0)->replace_value(new NS_SNMP SnmpInt32(p1));
}

//--AgentGen BEGIN=ifStackEntry
//--AgentGen END


/**
 *  ifTestEntry
 *
 * "An entry containing objects for invoking tests on an
 * interface."
 */
 
if_mib_ifTestEntry* if_mib_ifTestEntry::instance = 0;

const index_info ind_IF_MIB_IfTestEntry[1] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 }};

if_mib_ifTestEntry::if_mib_ifTestEntry():
   MibTable(oid_IF_MIB_IfTestEntry, ind_IF_MIB_IfTestEntry, 1)
{
	// This table object is a singleton. In order to access it use
	// the static pointer if_mib_ifTestEntry::instance.
	instance = this;

	add_col(new if_mib_ifTestId(col_IF_MIB_IfTestId));
	add_col(new if_mib_ifTestStatus(col_IF_MIB_IfTestStatus));
	add_col(new if_mib_ifTestType(col_IF_MIB_IfTestType));
	add_col(new MibLeaf(col_IF_MIB_IfTestResult, READONLY, new NS_SNMP SnmpInt32()));
	add_col(new MibLeaf(col_IF_MIB_IfTestCode, READONLY, new NS_SNMP Oid()));
	add_col(new if_mib_ifTestOwner(col_IF_MIB_IfTestOwner));
	//--AgentGen BEGIN=ifTestEntry::if_mib_ifTestEntry
	//--AgentGen END
        // If the code below does not suite your needs or
        // does not compile, because the parent table is
        // named differently, then add "/*" as last line 
        // to your user code.
	if (if_mib_ifEntry::instance) {
		if_mib_ifEntry::instance->add_listener(this);
	}
	else {
		LOG_BEGIN(agenProLogModule, WARNING_LOG | 1);
		LOG("Please instantiate if_mib_ifEntry before ifTestEntry");
		LOG_END;
	}
}

if_mib_ifTestEntry::~if_mib_ifTestEntry()
{
	//--AgentGen BEGIN=ifTestEntry::~if_mib_ifTestEntry
	//--AgentGen END
	// clear singleton reference
	if_mib_ifTestEntry::instance = 0;
        // If the code below does not suite your needs or
        // does not compile, because the parent table is
        // named differently, then add "/*" as last line 
        // to your user code.
	if (if_mib_ifEntry::instance) {
		if_mib_ifEntry::instance->remove_listener(this);
	}	
	//*/	
}

void if_mib_ifTestEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=ifTestEntry::row_added
	//--AgentGen END
	if (src) add_row(index);	
}

void if_mib_ifTestEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int if_mib_ifTestEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifTestEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifTestEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int if_mib_ifTestEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void if_mib_ifTestEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int if_mib_ifTestEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifTestEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void if_mib_ifTestEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=ifTestEntry::row_delete
	//--AgentGen END
	if (src) remove_row(index);	
}

void if_mib_ifTestEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=ifTestEntry::row_init
	//--AgentGen END
}

void if_mib_ifTestEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=ifTestEntry::row_activated
	//--AgentGen END
}

void if_mib_ifTestEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=ifTestEntry::row_deactivated
	//--AgentGen END
}

void if_mib_ifTestEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=ifTestEntry::update
	//--AgentGen END
}

int if_mib_ifTestEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                          int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=ifTestEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void if_mib_ifTestEntry::set_row(MibTableRow* r, long p1, long p2, const char* p3
		, long p4, const char* p5, const NS_SNMP OctetStr& p6
		)
{
	r->get_nth(0)->replace_value(new NS_SNMP SnmpInt32(p1));
	r->get_nth(1)->replace_value(new NS_SNMP SnmpInt32(p2));
	r->get_nth(2)->replace_value(new NS_SNMP Oid(p3));
	r->get_nth(3)->replace_value(new NS_SNMP SnmpInt32(p4));
	r->get_nth(4)->replace_value(new NS_SNMP Oid(p5));
	r->get_nth(5)->replace_value(new NS_SNMP OctetStr(p6));
}

//--AgentGen BEGIN=ifTestEntry
//--AgentGen END


/**
 *  ifRcvAddressEntry
 *
 * "A list of objects identifying an address for which the
 * system will accept packets/frames on the particular
 * interface identified by the index value ifIndex."
 */
 
if_mib_ifRcvAddressEntry* if_mib_ifRcvAddressEntry::instance = 0;

const index_info ind_IF_MIB_IfRcvAddressEntry[2] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 },
	 { sNMP_SYNTAX_OCTETS, FALSE, 0, 128 }};

if_mib_ifRcvAddressEntry::if_mib_ifRcvAddressEntry():
   MibTable(oid_IF_MIB_IfRcvAddressEntry, ind_IF_MIB_IfRcvAddressEntry, 2)
{
	// This table object is a singleton. In order to access it use
	// the static pointer if_mib_ifRcvAddressEntry::instance.
	instance = this;

	add_col(new if_mib_ifRcvAddressStatus(col_IF_MIB_IfRcvAddressStatus));
	add_col(new if_mib_ifRcvAddressType(col_IF_MIB_IfRcvAddressType));
	//--AgentGen BEGIN=ifRcvAddressEntry::if_mib_ifRcvAddressEntry
	//--AgentGen END
}

if_mib_ifRcvAddressEntry::~if_mib_ifRcvAddressEntry()
{
	//--AgentGen BEGIN=ifRcvAddressEntry::~if_mib_ifRcvAddressEntry
	//--AgentGen END
	// clear singleton reference
	if_mib_ifRcvAddressEntry::instance = 0;
}

void if_mib_ifRcvAddressEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=ifRcvAddressEntry::row_added
	//--AgentGen END
}

void if_mib_ifRcvAddressEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifRcvAddressEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int if_mib_ifRcvAddressEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=ifRcvAddressEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=ifRcvAddressEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int if_mib_ifRcvAddressEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void if_mib_ifRcvAddressEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int if_mib_ifRcvAddressEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=ifRcvAddressEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void if_mib_ifRcvAddressEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=ifRcvAddressEntry::row_delete
	//--AgentGen END
}

void if_mib_ifRcvAddressEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=ifRcvAddressEntry::row_init
	//--AgentGen END
}

void if_mib_ifRcvAddressEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=ifRcvAddressEntry::row_activated
	//--AgentGen END
}

void if_mib_ifRcvAddressEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=ifRcvAddressEntry::row_deactivated
	//--AgentGen END
}

void if_mib_ifRcvAddressEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=ifRcvAddressEntry::update
	//--AgentGen END
}

int if_mib_ifRcvAddressEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=ifRcvAddressEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void if_mib_ifRcvAddressEntry::set_row(MibTableRow* r, long p1, long p2)
{
	r->get_nth(0)->replace_value(new NS_SNMP SnmpInt32(p1));
	r->get_nth(1)->replace_value(new NS_SNMP SnmpInt32(p2));
}

//--AgentGen BEGIN=ifRcvAddressEntry
//--AgentGen END

// Notifications
#ifdef _SNMPv3


/**
 *  linkDown
 *
 * "A linkDown trap signifies that the SNMP entity, acting in
 * an agent role, has detected that the ifOperStatus object for
 * one of its communication links is about to enter the down
 * state from some other state (but not from the notPresent
 * state).  This other state is indicated by the included value
 * of ifOperStatus."
 */
 
if_mib_linkDown::if_mib_linkDown(): NotificationType()
{
	//--AgentGen BEGIN=linkDown::if_mib_linkDown
	//--AgentGen END
}

if_mib_linkDown::~if_mib_linkDown()
{
	//--AgentGen BEGIN=linkDown::~if_mib_linkDown
	//--AgentGen END
}

int if_mib_linkDown::notify(const NS_SNMP OctetStr& context, Vbx* vbs, int sz)
{
	//--AgentGen BEGIN=linkDown::generate
	//--AgentGen END
#ifndef _NO_LOGGING
	if (sz < 3) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: too few var binds (given) (expected)");
		LOG(sz);
		LOG(3);
		LOG_END;
		return SNMP_ERROR_WRONG_LENGTH;
	}
	if (!(vbs[0].get_oid().in_subtree_of("1.3.6.1.2.1.2.2.1.1"))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: wrong var bind (no.) (given) (expected)");
		LOG(1l);
		LOG(vbs[0].get_printable_oid());
		LOG("1.3.6.1.2.1.2.2.1.1");
		LOG_END;
		return SNMP_ERROR_GENERAL_VB_ERR;
	}
	if (!if_mib_ifEntry::instance->is_index_valid(if_mib_ifEntry::instance->index(vbs[0].get_oid()))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: wrong index of var bind (no.) (index)");
		LOG(1l);
		LOG(if_mib_ifEntry::instance->index(vbs[0].get_oid()).get_printable());
		LOG_END;
		return SNMP_ERROR_INCONSIS_NAME;
	}
	if (!(vbs[1].get_oid().in_subtree_of("1.3.6.1.2.1.2.2.1.7"))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: wrong var bind (no.) (given) (expected)");
		LOG(2l);
		LOG(vbs[1].get_printable_oid());
		LOG("1.3.6.1.2.1.2.2.1.7");
		LOG_END;
		return SNMP_ERROR_GENERAL_VB_ERR;
	}
	if (!if_mib_ifEntry::instance->is_index_valid(if_mib_ifEntry::instance->index(vbs[1].get_oid()))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: wrong index of var bind (no.) (index)");
		LOG(2l);
		LOG(if_mib_ifEntry::instance->index(vbs[1].get_oid()).get_printable());
		LOG_END;
		return SNMP_ERROR_INCONSIS_NAME;
	}
	if (!(vbs[2].get_oid().in_subtree_of("1.3.6.1.2.1.2.2.1.8"))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: wrong var bind (no.) (given) (expected)");
		LOG(3l);
		LOG(vbs[2].get_printable_oid());
		LOG("1.3.6.1.2.1.2.2.1.8");
		LOG_END;
		return SNMP_ERROR_GENERAL_VB_ERR;
	}
	if (!if_mib_ifEntry::instance->is_index_valid(if_mib_ifEntry::instance->index(vbs[2].get_oid()))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkDown: wrong index of var bind (no.) (index)");
		LOG(3l);
		LOG(if_mib_ifEntry::instance->index(vbs[2].get_oid()).get_printable());
		LOG_END;
		return SNMP_ERROR_INCONSIS_NAME;
	}
#endif
	return Mib::instance->notify(context, oid_IF_MIB_LinkDown, vbs, sz);
}

//--AgentGen BEGIN=linkDown
//--AgentGen END
#endif
#ifdef _SNMPv3


/**
 *  linkUp
 *
 * "A linkUp trap signifies that the SNMP entity, acting in an
 * agent role, has detected that the ifOperStatus object for
 * one of its communication links left the down state and
 * transitioned into some other state (but not into the
 * notPresent state).  This other state is indicated by the
 * included value of ifOperStatus."
 */
 
if_mib_linkUp::if_mib_linkUp(): NotificationType()
{
	//--AgentGen BEGIN=linkUp::if_mib_linkUp
	//--AgentGen END
}

if_mib_linkUp::~if_mib_linkUp()
{
	//--AgentGen BEGIN=linkUp::~if_mib_linkUp
	//--AgentGen END
}

int if_mib_linkUp::notify(const NS_SNMP OctetStr& context, Vbx* vbs, int sz)
{
	//--AgentGen BEGIN=linkUp::generate
	//--AgentGen END
#ifndef _NO_LOGGING
	if (sz < 3) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: too few var binds (given) (expected)");
		LOG(sz);
		LOG(3);
		LOG_END;
		return SNMP_ERROR_WRONG_LENGTH;
	}
	if (!(vbs[0].get_oid().in_subtree_of("1.3.6.1.2.1.2.2.1.1"))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: wrong var bind (no.) (given) (expected)");
		LOG(1l);
		LOG(vbs[0].get_printable_oid());
		LOG("1.3.6.1.2.1.2.2.1.1");
		LOG_END;
		return SNMP_ERROR_GENERAL_VB_ERR;
	}
	if (!if_mib_ifEntry::instance->is_index_valid(if_mib_ifEntry::instance->index(vbs[0].get_oid()))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: wrong index of var bind (no.) (index)");
		LOG(1l);
		LOG(if_mib_ifEntry::instance->index(vbs[0].get_oid()).get_printable());
		LOG_END;
		return SNMP_ERROR_INCONSIS_NAME;
	}
	if (!(vbs[1].get_oid().in_subtree_of("1.3.6.1.2.1.2.2.1.7"))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: wrong var bind (no.) (given) (expected)");
		LOG(2l);
		LOG(vbs[1].get_printable_oid());
		LOG("1.3.6.1.2.1.2.2.1.7");
		LOG_END;
		return SNMP_ERROR_GENERAL_VB_ERR;
	}
	if (!if_mib_ifEntry::instance->is_index_valid(if_mib_ifEntry::instance->index(vbs[1].get_oid()))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: wrong index of var bind (no.) (index)");
		LOG(2l);
		LOG(if_mib_ifEntry::instance->index(vbs[1].get_oid()).get_printable());
		LOG_END;
		return SNMP_ERROR_INCONSIS_NAME;
	}
	if (!(vbs[2].get_oid().in_subtree_of("1.3.6.1.2.1.2.2.1.8"))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: wrong var bind (no.) (given) (expected)");
		LOG(3l);
		LOG(vbs[2].get_printable_oid());
		LOG("1.3.6.1.2.1.2.2.1.8");
		LOG_END;
		return SNMP_ERROR_GENERAL_VB_ERR;
	}
	if (!if_mib_ifEntry::instance->is_index_valid(if_mib_ifEntry::instance->index(vbs[2].get_oid()))) {
		LOG_BEGIN(agenProLogModule, ERROR_LOG | 1);
		LOG("if_mib_linkUp: wrong index of var bind (no.) (index)");
		LOG(3l);
		LOG(if_mib_ifEntry::instance->index(vbs[2].get_oid()).get_printable());
		LOG_END;
		return SNMP_ERROR_INCONSIS_NAME;
	}
#endif
	return Mib::instance->notify(context, oid_IF_MIB_LinkUp, vbs, sz);
}

//--AgentGen BEGIN=linkUp
//--AgentGen END
#endif

// Group
if_mib::if_mib():
   MibGroup("1.3.6.1.2.1", "if_mib")
{
	//--AgentGen BEGIN=if_mib::if_mib
	//--AgentGen END
	add(new if_mib_ifNumber());
	add(new if_mib_ifTableLastChange());
	add(new if_mib_ifStackLastChange());
	add(new if_mib_ifEntry());
	add(new if_mib_ifXEntry());
	add(new if_mib_ifStackEntry());
	add(new if_mib_ifTestEntry());
	add(new if_mib_ifRcvAddressEntry());
	//--AgentGen BEGIN=if_mib::if_mib:post
	//--AgentGen END
}

//--AgentGen BEGIN=if_mib
//--AgentGen END



//--AgentGen BEGIN=_CLASSES
//--AgentGen END


#ifdef AGENTPP_NAMESPACE
}
#endif


//--AgentGen BEGIN=_END
//--AgentGen END

#endif

