 


//--AgentGen BEGIN=_BEGIN
//--AgentGen END

#ifndef _snmp_usm_dh_objects_mib_cpp
#define  _snmp_usm_dh_objects_mib_cpp

#include <agent_pp/agent++.h>
#include <snmp_usm_dh_objects_mib.h>
#include <module_includes.h>

//--AgentGen BEGIN=_INCLUDE
//--AgentGen END


#ifdef SNMP_PP_NAMESPACE
using namespace Snmp_pp;
#endif

#ifdef AGENTPP_NAMESPACE
namespace Agentpp {
#endif


static const char *agenProLogModule = "snmp_usm_dh_objects_mib";

//--AgentGen BEGIN=_UTIL_CLASSES
//--AgentGen END

// Scalar Objects


/**
 *  usmDHParameters
 *
 * "The public Diffie-Hellman parameters for doing a Diffie-Hellman
 * key agreement for this device.  This is encoded as an ASN.1
 * DHParameter per PKCS #3, section 9.  E.g.

 *     DHParameter ::= SEQUENCE {
 *        prime   INTEGER,   -- p
 *        base    INTEGER,   -- g
 *        privateValueLength  INTEGER OPTIONAL }


 * Implementors are encouraged to use either the values from
 * Oakley Group 1  or the values of from Oakley Group 2 as specified
 * in RFC-2409, The Internet Key Exchange, Section 6.1, 6.2 as the
 * default for this object.  Other values may be used, but the
 * security properties of those values MUST be well understood and
 * MUST meet the requirements of PKCS #3 for the selection of
 * Diffie-Hellman primes.

 *     In addition, any time usmDHParameters changes, all values of
 * type DHKeyChange will change and new random numbers MUST be
 * generated by the agent for each DHKeyChange object."
 */
 
snmp_usm_dh_objects_mib_usmDHParameters* snmp_usm_dh_objects_mib_usmDHParameters::instance = 0;


snmp_usm_dh_objects_mib_usmDHParameters::snmp_usm_dh_objects_mib_usmDHParameters():
    MibLeaf(oid_SNMP_USM_DH_OBJECTS_MIB_UsmDHParameters, READWRITE, new NS_SNMP OctetStr()){
	// This leaf object is a singleton. In order to access it use
	// the static pointer snmp_usm_dh_objects_mib_usmDHParameters::instance.
	instance = this;
	//--AgentGen BEGIN=usmDHParameters::snmp_usm_dh_objects_mib_usmDHParameters
	//--AgentGen END

}

snmp_usm_dh_objects_mib_usmDHParameters::~snmp_usm_dh_objects_mib_usmDHParameters()
{

	//--AgentGen BEGIN=usmDHParameters::~snmp_usm_dh_objects_mib_usmDHParameters
	//--AgentGen END

	// clear singleton reference
	snmp_usm_dh_objects_mib_usmDHParameters::instance = 0;
}

void snmp_usm_dh_objects_mib_usmDHParameters::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHParameters::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr snmp_usm_dh_objects_mib_usmDHParameters::get_state() {
	//--AgentGen BEGIN=usmDHParameters::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void snmp_usm_dh_objects_mib_usmDHParameters::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=usmDHParameters::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int snmp_usm_dh_objects_mib_usmDHParameters::set(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHParameters::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int snmp_usm_dh_objects_mib_usmDHParameters::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHParameters::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHParameters::commit_set_request2
	//--AgentGen END
	return status;
}

void snmp_usm_dh_objects_mib_usmDHParameters::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHParameters::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHParameters::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHParameters::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool snmp_usm_dh_objects_mib_usmDHParameters::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHParameters::value_ok
	//--AgentGen END
	return TRUE;
}

int snmp_usm_dh_objects_mib_usmDHParameters::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=usmDHParameters::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=usmDHParameters
//--AgentGen END



// Columnar Objects


/**
 *  usmDHUserAuthKeyChange
 *
 * "The object used to change any given user's Authentication Key
 * using a Diffie-Hellman key exchange.

 * The right-most n bits of the shared secret 'sk', where 'n' is the
 * number of bits required for the protocol defined by
 * usmUserAuthProtocol, are installed as the operational
 * authentication key for this row after a successful SET."
 */
 
snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange(const Oidx& id):
    MibLeaf(id, READCREATE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange
	//--AgentGen END

}

snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::~snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange()
{

	//--AgentGen BEGIN=usmDHUserAuthKeyChange::~snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange
	//--AgentGen END

}

MibEntryPtr snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::clone()
{
	MibEntryPtr other = new snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange(oid);
	((snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange*)other)->replace_value(value->clone());
	((snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::clone
	//--AgentGen END
	return other;
}

void snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::get_state() {
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::set(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::commit_set_request2
	//--AgentGen END
	return status;
}

void snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserAuthKeyChange::value_ok
	//--AgentGen END
	return TRUE;
}

int snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=usmDHUserAuthKeyChange::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=usmDHUserAuthKeyChange
//--AgentGen END




/**
 *  usmDHUserOwnAuthKeyChange
 *
 * "The object used to change the agents own Authentication Key
 * using a Diffie-Hellman key exchange.

 * The right-most n bits of the shared secret 'sk', where 'n' is the
 * number of bits required for the protocol defined by
 * usmUserAuthProtocol, are installed as the operational
 * authentication key for this row after a successful SET."
 */
 
snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange(const Oidx& id):
    MibLeaf(id, READCREATE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange
	//--AgentGen END

}

snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::~snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange()
{

	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::~snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange
	//--AgentGen END

}

MibEntryPtr snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::clone()
{
	MibEntryPtr other = new snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange(oid);
	((snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange*)other)->replace_value(value->clone());
	((snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::clone
	//--AgentGen END
	return other;
}

void snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::get_state() {
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::set(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::commit_set_request2
	//--AgentGen END
	return status;
}

void snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::value_ok
	//--AgentGen END
	return TRUE;
}

int snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=usmDHUserOwnAuthKeyChange
//--AgentGen END




/**
 *  usmDHUserPrivKeyChange
 *
 * "The object used to change any given user's Privacy Key using
 * a Diffie-Hellman key exchange.

 * The right-most n bits of the shared secret 'sk', where 'n' is the
 * number of bits required for the protocol defined by
 * usmUserPrivProtocol, are installed as the operational privacy key
 * for this row after a successful SET."
 */
 
snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange(const Oidx& id):
    MibLeaf(id, READCREATE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange
	//--AgentGen END

}

snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::~snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange()
{

	//--AgentGen BEGIN=usmDHUserPrivKeyChange::~snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange
	//--AgentGen END

}

MibEntryPtr snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::clone()
{
	MibEntryPtr other = new snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange(oid);
	((snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange*)other)->replace_value(value->clone());
	((snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::clone
	//--AgentGen END
	return other;
}

void snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::get_state() {
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::set(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::commit_set_request2
	//--AgentGen END
	return status;
}

void snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserPrivKeyChange::value_ok
	//--AgentGen END
	return TRUE;
}

int snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=usmDHUserPrivKeyChange::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=usmDHUserPrivKeyChange
//--AgentGen END




/**
 *  usmDHUserOwnPrivKeyChange
 *
 * "The object used to change the agent's own Privacy Key using a
 * Diffie-Hellman key exchange.

 * The right-most n bits of the shared secret 'sk', where 'n' is the
 * number of bits required for the protocol defined by
 * usmUserPrivProtocol, are installed as the operational privacy key
 * for this row after a successful SET."
 */
 
snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange(const Oidx& id):
    MibLeaf(id, READCREATE, new NS_SNMP OctetStr()){
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange
	//--AgentGen END

}

snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::~snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange()
{

	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::~snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange
	//--AgentGen END

}

MibEntryPtr snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::clone()
{
	MibEntryPtr other = new snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange(oid);
	((snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange*)other)->replace_value(value->clone());
	((snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange*)other)->set_reference_to_table(my_table);
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::clone
	//--AgentGen END
	return other;
}

void snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::get_request
	//--AgentGen END
	MibLeaf::get_request(req, ind);
}

NS_SNMP OctetStr snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::get_state() {
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::get_state
	//--AgentGen END
	return *((NS_SNMP OctetStr*)value);
}
void snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::set_state(const NS_SNMP OctetStr& s)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::set_state
	//--AgentGen END
	*((NS_SNMP OctetStr*)value) = s;
}


int snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::set(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::set
	//--AgentGen END
	return MibLeaf::set(vb);
}

int snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::commit_set_request
	//--AgentGen END
	int status = MibLeaf::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::commit_set_request2
	//--AgentGen END
	return status;
}

void snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::cleanup_set_request
	//--AgentGen END
	MibLeaf::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::undo_set_request
	//--AgentGen END
	return MibLeaf::undo_set_request(req, ind);
}

bool snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::value_ok(const Vbx& vb)
{
	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::value_ok
	//--AgentGen END
	return TRUE;
}

int snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange::prepare_set_request(Request* req, int& ind)
{
	int status;
	if ((status = MibLeaf::prepare_set_request(req, ind)) !=
	    SNMP_ERROR_SUCCESS) return status;

	//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange::prepare_set_request
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}

//--AgentGen BEGIN=usmDHUserOwnPrivKeyChange
//--AgentGen END



// Tables


/**
 *  usmDHUserKeyEntry
 *
 * "A row of DHKeyChange objects which augment or replace the
 * functionality of the KeyChange objects in the base table row."
 */
 
snmp_usm_dh_objects_mib_usmDHUserKeyEntry* snmp_usm_dh_objects_mib_usmDHUserKeyEntry::instance = 0;

const index_info ind_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserKeyEntry[2] = {
	{ sNMP_SYNTAX_OCTETS, FALSE, 5, 32 }
,
	 { sNMP_SYNTAX_OCTETS, FALSE, 1, 32 }
};

snmp_usm_dh_objects_mib_usmDHUserKeyEntry::snmp_usm_dh_objects_mib_usmDHUserKeyEntry():
   MibTable(oid_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserKeyEntry, ind_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserKeyEntry, 2)
{
	// This table object is a singleton. In order to access it use
	// the static pointer snmp_usm_dh_objects_mib_usmDHUserKeyEntry::instance.
	instance = this;

	add_col(new snmp_usm_dh_objects_mib_usmDHUserAuthKeyChange(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserAuthKeyChange));
	add_col(new snmp_usm_dh_objects_mib_usmDHUserOwnAuthKeyChange(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserOwnAuthKeyChange));
	add_col(new snmp_usm_dh_objects_mib_usmDHUserPrivKeyChange(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserPrivKeyChange));
	add_col(new snmp_usm_dh_objects_mib_usmDHUserOwnPrivKeyChange(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHUserOwnPrivKeyChange));
	//--AgentGen BEGIN=usmDHUserKeyEntry::snmp_usm_dh_objects_mib_usmDHUserKeyEntry
	//--AgentGen END
        // If the code below does not suite your needs or
        // does not compile, because the parent table is
        // named differently, then add "/*" as last line 
        // to your user code.
	if (snmp_user_based_sm_mib_usmUserEntry::instance) {
		snmp_user_based_sm_mib_usmUserEntry::instance->add_listener(this);
	}
	else {
		LOG_BEGIN(agenProLogModule, WARNING_LOG | 1);
		LOG("Please instantiate snmp_user_based_sm_mib_usmUserEntry before usmDHUserKeyEntry");
		LOG_END;
	}
}

snmp_usm_dh_objects_mib_usmDHUserKeyEntry::~snmp_usm_dh_objects_mib_usmDHUserKeyEntry()
{
	//--AgentGen BEGIN=usmDHUserKeyEntry::~snmp_usm_dh_objects_mib_usmDHUserKeyEntry
	//--AgentGen END
	// clear singleton reference
	snmp_usm_dh_objects_mib_usmDHUserKeyEntry::instance = 0;
        // If the code below does not suite your needs or
        // does not compile, because the parent table is
        // named differently, then add "/*" as last line 
        // to your user code.
	if (snmp_user_based_sm_mib_usmUserEntry::instance) {
		snmp_user_based_sm_mib_usmUserEntry::instance->remove_listener(this);
	}	
	//*/	
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=usmDHUserKeyEntry::row_added
	//--AgentGen END
	if (src) add_row(index);	
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserKeyEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHUserKeyEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHUserKeyEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHUserKeyEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int snmp_usm_dh_objects_mib_usmDHUserKeyEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserKeyEntry::prepare_set_request
	//--AgentGen END
	Oidx oid(req->get_oid(ind));
	if (!find(oid)) {
		Oidx rs("1.3.6.1.6.3.15.1.2.2.1");
		rs += index(oid);
		Vbx* status = req->search_value(rs);
		if (!status)
			return SNMP_ERROR_INCONSIS_NAME;
		long value = 0;
		status->get_value(value);
		delete status;
		if ((value != rowCreateAndWait) && 
		    (value != rowCreateAndGo)) {
			return SNMP_ERROR_INCONSIS_NAME;
		}
	}
	return MibTable::prepare_set_request(req, ind);
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserKeyEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHUserKeyEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHUserKeyEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=usmDHUserKeyEntry::row_delete
	//--AgentGen END
	if (src) remove_row(index);	
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=usmDHUserKeyEntry::row_init
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=usmDHUserKeyEntry::row_activated
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=usmDHUserKeyEntry::row_deactivated
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=usmDHUserKeyEntry::update
	//--AgentGen END
}

int snmp_usm_dh_objects_mib_usmDHUserKeyEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                                 int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=usmDHUserKeyEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void snmp_usm_dh_objects_mib_usmDHUserKeyEntry::set_row(MibTableRow* r, const NS_SNMP OctetStr& p1, const NS_SNMP OctetStr& p2, const NS_SNMP OctetStr& p3
		, const NS_SNMP OctetStr& p4)
{
	r->get_nth(0)->replace_value(new NS_SNMP OctetStr(p1));
	r->get_nth(1)->replace_value(new NS_SNMP OctetStr(p2));
	r->get_nth(2)->replace_value(new NS_SNMP OctetStr(p3));
	r->get_nth(3)->replace_value(new NS_SNMP OctetStr(p4));
}

//--AgentGen BEGIN=usmDHUserKeyEntry
//--AgentGen END


/**
 *  usmDHKickstartEntry
 *
 * "An entry in the usmDHKickstartTable.  The agent SHOULD either
 * delete this entry or mark it as inactive upon a successful SET of
 * any of the KeyChange-typed objects in the usmUserEntry or upon a
 * successful SET of any of the DHKeyChange-typed objects in the
 * usmDhKeyChangeEntry where the related usmSecurityName (e.g. row of
 * usmUserTable or row of ushDhKeyChangeTable) equals this entry's
 * usmDhKickstartSecurityName.  In otherwords, once you've changed
 * one or more of the keys for a row in usmUserTable with a
 * particular security name, the row in this table with that same
 * security name is no longer useful or meaningful."
 */
 
snmp_usm_dh_objects_mib_usmDHKickstartEntry* snmp_usm_dh_objects_mib_usmDHKickstartEntry::instance = 0;

const index_info ind_SNMP_USM_DH_OBJECTS_MIB_UsmDHKickstartEntry[1] = {
	{ sNMP_SYNTAX_INT, FALSE, 1, 1 }};

snmp_usm_dh_objects_mib_usmDHKickstartEntry::snmp_usm_dh_objects_mib_usmDHKickstartEntry():
   MibTable(oid_SNMP_USM_DH_OBJECTS_MIB_UsmDHKickstartEntry, ind_SNMP_USM_DH_OBJECTS_MIB_UsmDHKickstartEntry, 1)
{
	// This table object is a singleton. In order to access it use
	// the static pointer snmp_usm_dh_objects_mib_usmDHKickstartEntry::instance.
	instance = this;

	add_col(new MibLeaf(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHKickstartMyPublic, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHKickstartMgrPublic, READONLY, new NS_SNMP OctetStr()));
	add_col(new MibLeaf(col_SNMP_USM_DH_OBJECTS_MIB_UsmDHKickstartSecurityName, READONLY, new NS_SNMP OctetStr()));
	//--AgentGen BEGIN=usmDHKickstartEntry::snmp_usm_dh_objects_mib_usmDHKickstartEntry
	//--AgentGen END
}

snmp_usm_dh_objects_mib_usmDHKickstartEntry::~snmp_usm_dh_objects_mib_usmDHKickstartEntry()
{
	//--AgentGen BEGIN=usmDHKickstartEntry::~snmp_usm_dh_objects_mib_usmDHKickstartEntry
	//--AgentGen END
	// clear singleton reference
	snmp_usm_dh_objects_mib_usmDHKickstartEntry::instance = 0;
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::row_added(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been added to the table.
	//--AgentGen BEGIN=usmDHKickstartEntry::row_added
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::get_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHKickstartEntry::get_request
	//--AgentGen END
	MibTable::get_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHKickstartEntry::commit_set_request(Request* req, int ind)
{
	//--AgentGen BEGIN=usmDHKickstartEntry::commit_set_request
	//--AgentGen END
	int status = MibTable::commit_set_request(req, ind);
	//--AgentGen BEGIN=usmDHKickstartEntry::commit_set_request2
	//--AgentGen END
	return status;
}

int snmp_usm_dh_objects_mib_usmDHKickstartEntry::prepare_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHKickstartEntry::prepare_set_request
	//--AgentGen END
	return MibTable::prepare_set_request(req, ind);
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::cleanup_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHKickstartEntry::cleanup_set_request
	//--AgentGen END
	MibTable::cleanup_set_request(req, ind);
}

int snmp_usm_dh_objects_mib_usmDHKickstartEntry::undo_set_request(Request* req, int& ind)
{
	//--AgentGen BEGIN=usmDHKickstartEntry::undo_set_request
	//--AgentGen END
	return MibTable::undo_set_request(req, ind);
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::row_delete(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' will be deleted.
	//--AgentGen BEGIN=usmDHKickstartEntry::row_delete
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::row_init(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been intialized.
	//--AgentGen BEGIN=usmDHKickstartEntry::row_init
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::row_activated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been activated.
	//--AgentGen BEGIN=usmDHKickstartEntry::row_activated
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::row_deactivated(MibTableRow* row, const Oidx& index, MibTable* src)
{
	// The row 'row' with 'index' has been deactivated.
	//--AgentGen BEGIN=usmDHKickstartEntry::row_deactivated
	//--AgentGen END
}

void snmp_usm_dh_objects_mib_usmDHKickstartEntry::update(Request* req)
{
	// This table needs to be updated.
	//--AgentGen BEGIN=usmDHKickstartEntry::update
	//--AgentGen END
}

int snmp_usm_dh_objects_mib_usmDHKickstartEntry::is_transition_ok(MibTable* table, MibTableRow* row, const Oidx& index,
                                                                   int currentStatus, int requestedStatus)
{
	// The row 'row' with 'index' from 'table' (which will be 0 for local table)
	// is requested to change status. Accept or deny this state change here.
	//--AgentGen BEGIN=usmDHKickstartEntry::is_transition_ok
	//--AgentGen END
	return SNMP_ERROR_SUCCESS;
}



void snmp_usm_dh_objects_mib_usmDHKickstartEntry::set_row(MibTableRow* r, const NS_SNMP OctetStr& p1, const NS_SNMP OctetStr& p2, const NS_SNMP OctetStr& p3
		)
{
	r->get_nth(0)->replace_value(new NS_SNMP OctetStr(p1));
	r->get_nth(1)->replace_value(new NS_SNMP OctetStr(p2));
	r->get_nth(2)->replace_value(new NS_SNMP OctetStr(p3));
}

//--AgentGen BEGIN=usmDHKickstartEntry
//--AgentGen END

// Notifications

// Group
snmp_usm_dh_objects_mib::snmp_usm_dh_objects_mib():
   MibGroup("1.3.6.1.3.101", "snmp_usm_dh_objects_mib")
{
	//--AgentGen BEGIN=snmp_usm_dh_objects_mib::snmp_usm_dh_objects_mib
	//--AgentGen END
	add(new snmp_usm_dh_objects_mib_usmDHParameters());
	add(new snmp_usm_dh_objects_mib_usmDHUserKeyEntry());
	add(new snmp_usm_dh_objects_mib_usmDHKickstartEntry());
	//--AgentGen BEGIN=snmp_usm_dh_objects_mib::snmp_usm_dh_objects_mib:post
	//--AgentGen END
}

//--AgentGen BEGIN=snmp_usm_dh_objects_mib
//--AgentGen END



//--AgentGen BEGIN=_CLASSES
//--AgentGen END


#ifdef AGENTPP_NAMESPACE
}
#endif


//--AgentGen BEGIN=_END
//--AgentGen END

#endif

